"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _fs = require("fs");

var _buildDll = _interopRequireDefault(require("./buildDll"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _default(api, opts = {}) {
  // TODO: generateDll command
  // api.registerCommand('generateDll', () => {
  // });
  if (process.env.NODE_ENV !== 'development') return;
  const _api$utils = api.utils,
        webpack = _api$utils._webpack,
        afWebpackGetConfig = _api$utils._afWebpackGetConfig,
        afWebpackBuild = _api$utils._afWebpackBuild,
        webpackHotDevClientPath = _api$utils._webpackHotDevClientPath;
  const paths = api.service.paths;
  const dllDir = (0, _path.join)(paths.absNodeModulesPath, 'umi-dlls');
  const dllFile = (0, _path.join)(dllDir, 'umi.dll.js');
  const dllManifest = (0, _path.join)(dllDir, 'umi.json');
  api.register('beforeDevAsync', () => {
    return new Promise(resolve => {
      (0, _buildDll.default)(_objectSpread({
        webpack,
        afWebpackGetConfig,
        afWebpackBuild,
        webpackHotDevClientPath,
        service: api.service,
        dllDir
      }, opts)).then(() => {
        resolve();
      }).catch(e => {
        console.log('[umi-plugin-dll] error', e);
      });
    });
  });
  api.register('modifyMiddlewares', ({
    memo
  }) => {
    memo.push((req, res, next) => {
      if (req.path === '/__umi.dll.js') {
        const content = (0, _fs.existsSync)(dllFile) ? (0, _fs.readFileSync)(dllFile, 'utf-8') : `console.error('File pages/.umi/dll/umi.dll.js not found, please reload after it\'s ready.');`;
        res.setHeader('Content-Type', 'text/javascript');
        res.end(content);
      } else {
        next();
      }
    });
    return memo;
  });
  api.register('modifyWebpackConfig', ({
    memo
  }) => {
    memo.plugins.push(new webpack.DllReferencePlugin({
      context: paths.absSrcPath,
      manifest: dllManifest
    }));
    return memo;
  });
  api.register('modifyHTML', ({
    memo
  }) => {
    memo = memo.replace('</head>', `
<script src="/__umi.dll.js"></script>
</head>
    `.trim());
    return memo;
  });
}